unit DiscreteSeriesDemo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ToolWin, ExtCtrls, TeeProcs, TeEngine, Chart,
  SignalToolsTee, TeeEdit, MtxBaseComp,Series, StdCtrls, TeeTools,
  MtxDialogs, SignalUtils, MtxComCtrls, SignalSeriesTee;

type
  TDiscreteSeriesDemoForm = class(TForm)
    Panel1: TPanel;
    ToolBar1: TToolBar;
    ChartEditButton: TToolButton;
    ChartEditor: TChartEditor;
    RichEdit1: TRichEdit;
    Panel2: TPanel;
    Splitter1: TSplitter;
    SignalChart1: TSignalChart;
    Series1: TSignalDiscreteSeries;
    StepEdit: TMtxFloatEdit;
    Label1: TLabel;
    procedure ChartEditButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure StepEditChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DiscreteSeriesDemoForm: TDiscreteSeriesDemoForm;

implementation

uses Math387, MtxVec, MtxVecTee;

{$R *.dfm}

procedure TDiscreteSeriesDemoForm.ChartEditButtonClick(Sender: TObject);
begin
    ChartEditor.Execute;
end;

procedure TDiscreteSeriesDemoForm.FormCreate(Sender: TObject);
begin
    StepEditChange(Sender); 
    With RichEdit1.Lines, RichEdit1 do
    begin
      Clear;
      Add('A new chart series for drawing discrete signals. The example below ' +
          'shows an oversampled FIR filter.');
    end;
end;

procedure TDiscreteSeriesDemoForm.StepEditChange(Sender: TObject);
var H: TVec;
    Step: TSample;
begin
    CreateIt(H);
    try
        Step := StepEdit.Position;
        FractionalFirImpulse(30,0,Step,H,[0.2,0.25],ftLowpass,1);
        SignalChart1.Series[0].Clear;
        DrawValues(H,SignalChart1.Series[0],0,Step);
    finally
        FreeIt(H);
    end;
end;

initialization
RegisterClass(TDiscreteSeriesDemoForm);

end.
