unit MonitorDemo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ToolWin, ExtCtrls, TeeProcs, TeEngine, Chart,
  SignalToolsTee, TeeEdit, SignalToolsDialogs, SpectrumAna, MtxBaseComp,
  SignalTools, SignalAnalysis, Series, StdCtrls, TeeTools, FileSignal,
  MtxDialogs, SignalProcessing, AudioSignal, MtxComCtrls, SignalUtils,
  Buttons;

type
  TMonitorDemoForm = class(TForm)
    Panel1: TPanel;
    ToolBar1: TToolBar;
    SpectrumEditButton: TToolButton;
    ChartButton: TToolButton;
    SpectrumAnalyzer: TSpectrumAnalyzer;
    SpectrumAnalyzerDialog: TSpectrumAnalyzerDialog;
    ChartEditor: TChartEditor;
    RichEdit1: TRichEdit;
    Panel2: TPanel;
    SpectrumChart: TSpectrumChart;
    Series1: TFastLineSeries;
    Series2: TPointSeries;
    ChartTool1: TAxisScaleTool;
    Splitter1: TSplitter;
    SignalChart1: TSignalChart;
    Series3: TFastLineSeries;
    SignalTimer1: TSignalTimer;
    SignalIn1: TSignalIn;
    Signal1: TSignal;
    ChannelBox: TComboBox;
    Label1: TLabel;
    RecordToFileBox: TCheckBox;
    SignalWrite1: TSignalWrite;
    procedure SpectrumEditButtonClick(Sender: TObject);
    procedure SpectrumAnalyzerParameterUpdate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Panel2Resize(Sender: TObject);
    procedure SignalTimer1Timer(Sender: TObject);
    procedure ChartButtonClick(Sender: TObject);
    procedure RecordToFileBoxClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MonitorDemoForm: TMonitorDemoForm;

implementation

uses Math387, MtxVec;

{$R *.dfm}

procedure TMonitorDemoForm.SpectrumEditButtonClick(Sender: TObject);
begin
    SpectrumAnalyzerDialog.Execute;
end;

procedure TMonitorDemoForm.SpectrumAnalyzerParameterUpdate(
  Sender: TObject);
begin
    SpectrumAnalyzer.Update;
end;

procedure TMonitorDemoForm.FormCreate(Sender: TObject);
begin
//    SignalIn1.MonitorAggressiveness := 50; 
    Signal1.Data.Size(4096);  //defines how much data to copy and consequently also frequency resolution
    Signal1.Data.SetZero;
    Signal1.UsesInputs := false;
    SignalWrite1.Precision := prSmallInt; //or prInteger or prByte (others will not work).

    ChannelBox.ItemIndex := 0;

    With RichEdit1.Lines, RichEdit1 do
    begin
      Clear;
      Add('The recording is set up for 44kHz stereo. The best way to test this demo is to ' +
          'speak in to the microphone. You can select the channel you wish to monitor.' +
          'If Record to file checkbox is checked, the signal will be recorded to C:\test.wav.' +
          'Note the responsivnes of the charts (a very short delay from the time you speak  ' +
          'to when the display shows the change) while recording to file.');
    end;
end;


procedure TMonitorDemoForm.Panel2Resize(Sender: TObject);
begin
    SpectrumChart.Height := Panel2.Height div 2;
end;

procedure TMonitorDemoForm.SignalTimer1Timer(Sender: TObject);
begin
    if not SignalIn1.Active then SignalIn1.Start;
    case TChannel(ChannelBox.ItemIndex) of
    chLeft:  SignalIn1.MonitorData(Signal1, nil    );
    chRight: SignalIn1.MonitorData(nil    , Signal1);
    end;
    SpectrumAnalyzer.Pull;  //calls update on Signal1 and Self
end;

procedure TMonitorDemoForm.ChartButtonClick(Sender: TObject);
begin
    ChartEditor.Execute;
end;

procedure TMonitorDemoForm.RecordToFileBoxClick(Sender: TObject);
begin
    SignalWrite1.Active := RecordToFileBox.Checked;
end;

initialization
RegisterClass(TMonitorDemoForm);

end.
