{******************************************}
{ TCursorTool Editor Dialog                }
{ Copyright (c) 1999-2001 by David Berneda }
{******************************************}
unit AxisScaleToolEdit;
{$I bdsppdefs.inc}

interface

Uses {$IFNDEF LINUX}
     Windows, Messages,
     {$ENDIF}
     SysUtils, Classes,
     {$IFDEF CLX}
     QGraphics, QControls, QForms, QDialogs, QStdCtrls, QExtCtrls, QComCtrls,
     {$ELSE}
     Graphics, Controls, Forms, Dialogs, StdCtrls, ExtCtrls, ComCtrls,
     {$ENDIF}
     TeePenDlg, TeCanvas, TeeProcs, SignalToolsTee, Buttons;

type
  TAxisScaleToolEditor = class(TForm)
    CBAxis: TComboBox;
    Label1: TLabel;
    ScaleModeBox: TComboBox;
    Label2: TLabel;
    UpperMarginEdit: TEdit;
    LowerMarginEdit: TEdit;
    UpDown1: TUpDown;
    UpDown2: TUpDown;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    AutoMinBox: TCheckBox;
    AutoMaxBox: TCheckBox;
    SpeedButton1: TSpeedButton;
    IsSpectrum: TCheckBox;
    procedure FormShow(Sender: TObject);
    procedure CBAxisChange(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure ScaleModeBoxChange(Sender: TObject);
    procedure AutoMinBoxClick(Sender: TObject);
    procedure AutoMaxBoxClick(Sender: TObject);
    procedure UpperMarginEditChange(Sender: TObject);
    procedure LowerMarginEditChange(Sender: TObject);
    procedure IsSpectrumClick(Sender: TObject);
  private
    { Private declarations }
    AxisTool : TAxisScaleTool;
  public
    { Public declarations }
  end;

implementation

{$R *.dfm}

Uses TeEngine,TeeEdiAxis, TeeTools;

procedure TAxisScaleToolEditor.FormShow(Sender: TObject);
begin
  AxisTool:= TAxisScaleTool(Tag);
  TeeAddAxes(AxisTool.ParentChart,CBAxis.Items,False);
  With AxisTool do
  begin
    With ParentChart,CBAxis do
    if Axis=LeftAxis then ItemIndex:=0 else
    if Axis=RightAxis then ItemIndex:=1 else
    if Axis=TopAxis then ItemIndex:=2 else
    if Axis=BottomAxis then ItemIndex:=3 else
       ItemIndex:=Axes.IndexOf(Axis)-1;
  end;
  if Assigned(AxisTool.Axis) then
  begin
      ScaleModeBox.ItemIndex := Integer(AxisTool.AxisScaleMode);
      AutoMinBox.Checked := AxisTool.Axis.AutomaticMinimum;
      AutoMaxBox.Checked := AxisTool.Axis.AutomaticMaximum;
      UpDown1.Position := AxisTool.UpperMargin;
      UpDown2.Position := AxisTool.LowerMargin;
      IsSpectrum.Checked := AxisTool.DataIsSpectrum;
  end;
end;

procedure TAxisScaleToolEditor.CBAxisChange(Sender: TObject);
begin
  if Assigned(AxisTool) then
  With AxisTool do
  Case CBAxis.ItemIndex of
    -1: Axis:=nil;
     0: Axis:=ParentChart.LeftAxis;
     1: Axis:=ParentChart.RightAxis;
     2: Axis:=ParentChart.TopAxis;
     3: Axis:=ParentChart.BottomAxis;
  else
    Axis:=ParentChart.Axes[CBAxis.ItemIndex+1];
  end;
end;

procedure TAxisScaleToolEditor.SpeedButton1Click(Sender: TObject);
begin
      if Assigned(AxisTool) then  AxisTool.Reset;
end;

procedure TAxisScaleToolEditor.ScaleModeBoxChange(Sender: TObject);
begin
      if Assigned(AxisTool) then
      if Assigned(AxisTool.Axis) then
      AxisTool.AxisScaleMode := TAxisScaleMode(ScaleModeBox.ItemIndex);
end;

procedure TAxisScaleToolEditor.AutoMinBoxClick(Sender: TObject);
begin
      if Assigned(AxisTool) then
      if Assigned(AxisTool.Axis) then
      AxisTool.Axis.AutomaticMinimum := AutoMinBox.Checked;
end;

procedure TAxisScaleToolEditor.AutoMaxBoxClick(Sender: TObject);
begin
      if Assigned(AxisTool) then
      if Assigned(AxisTool.Axis) then
      AxisTool.Axis.AutomaticMaximum := AutoMaxBox.Checked;
end;

procedure TAxisScaleToolEditor.UpperMarginEditChange(Sender: TObject);
begin
      if Assigned(AxisTool) then
      AxisTool.UpperMargin := StrToInt(UpperMarginEdit.Text);
end;

procedure TAxisScaleToolEditor.LowerMarginEditChange(Sender: TObject);
begin
      if Assigned(AxisTool) then
      AxisTool.LowerMargin := StrToInt(LowerMarginEdit.Text);
end;

procedure TAxisScaleToolEditor.IsSpectrumClick(Sender: TObject);
begin
      if Assigned(AxisTool) then
      if Assigned(AxisTool.Axis) then
      AxisTool.DataIsSpectrum := IsSpectrum.Checked;
end;

initialization
  RegisterClass(TAxisScaleToolEditor);
end.
